var api = require("../../utils/api.js");
import { API_SCAN } from '../../const/apiurl'
import { ACTION_GOODS } from '../../const/actioncmd'
import { ACTION_GO_BALANCE } from '../../const/actioncmd'
import { ACTION_REQUEST_GOOD_INFO } from '../../const/actioncmd'
import { ACTION_PRINT_RESULT } from '../../const/actioncmd'
import { ACTION_REPRINT } from '../../const/actioncmd'
import { ACTION_GO_SCAN } from '../../const/actioncmd'
import { ACTION_ON_PAY_SUCCESS } from '../../const/actioncmd'
import { ACTION_ON_PAY_FAILED } from '../../const/actioncmd'
import { ACTION_GO_HOME } from '../../const/actioncmd'
import { ACTION_GET_ACCOUNT } from '../../const/actioncmd'

Page({
  data: {
    //页面控制相关参数
    pageShow: {
      "home": true,
      "landscan": false,
      "waitoperate": false,
      "payresult": false
    },
    storeName: "--",
    /**支付结果页相关参数 */
    payFailedReason: "xxxxxxxxxxx",
    isPaySuccess: true,
    payPriceYuan: "--.--",
    printResult: "正在打印小票...",
    isPrinting: false,
    isPrintSuccess: false,
    payPriceFen: 0,
    /**商品扫码页相关参数 */
    //是否正在用券
    couponUseing: false,
    //0代表弹窗关闭 1代表手动输入条码弹窗 2代表会员 3.收款 4.退款 
    scene: 0,
    //总数量
    totalQuantity: 0,
    //折后价格
    totalPrice: 0.00,
    //折扣
    totalDisc: 0.00,
    goods: [
    ]
  },

  /**跳转页面方法 */
  goPage(pageName) {
    var pageShowTemp = {
      "home": false,
      "landscan": false,
      "waitoperate": false,
      "payresult": false
    };
    //遍历pageShow
    for (var key in pageShowTemp) {
      if (key == pageName) {
        pageShowTemp[key] = true;
      } else {
        pageShowTemp[key] = false;
      }
    }
    this.setData({
      pageShow: pageShowTemp
    });
  },


  onLoad(query) {
    // 页面加载
    console.info(`Page onLoad with query: ${JSON.stringify(query)}`);
  },
  onReady() {
    // 页面加载完成
  },
  onShow() {
    // 页面显示
    let context = this;
    //开启后屏监听
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);

        if (res.action == ACTION_PRINT_RESULT && context.data.pageShow['payresult'] == true) {
          //获取到打印结果
          var printResultData = res.data;
          if (printResultData.code == 0) {
            //打印成功
            context.setData({
              isPrintSuccess: true,
              isPrinting: false,
              printResult: "打印成功"
            });
          } else {
            //打印失败
            context.setData({
              isPrintSuccess: false,
              isPrinting: false,
              printResult: "打印失败"
            });
          }
        } else if (res.action == ACTION_GO_HOME) {
          //重制打印状态
          this.setData({
            isPrinting: true,
            printResult: "正在打印...",
            payPriceYuan: "--.--",
            payPriceFen: 0
          });
          //跳首页
          context.goPage('home');
        } else if (res.action == ACTION_GOODS) {
          //商品信息同步
          my.hideLoading();
          let viewGoodsInfo = res.data
          if (viewGoodsInfo.goods != null && viewGoodsInfo.goods.length > 0) {
            context.setData({
              goods: viewGoodsInfo.goods,
              totalPrice: viewGoodsInfo.totalPrice,
              totalQuantity: viewGoodsInfo.totalQuantity,
              totalDisc: viewGoodsInfo.totalDisc,
            })
          }
        } else if (res.action == ACTION_GO_SCAN) {
          //跳转到
          context.goPage('landscan');
        } else if (res.action == ACTION_GO_BALANCE) {
          //跳转
          context.goPage('waitoperate');
        } else if (res.action == ACTION_ON_PAY_SUCCESS) {

          //分转元
          var miyapay = require("/utils/miyapay4.js");

          context.setData({
            isPaySuccess: true,
            payPriceFen: res.data.tradeAmount,
            payPriceYuan: miyapay.fen2Yuan(res.data.tradeAmount) + "",
          });
          context.goPage('payresult');
        } else if (res.action == ACTION_ON_PAY_FAILED) {

          context.setData({
            isPaySuccess: false,
          });

          context.goPage('payresult');
        } else if(res.action == ACTION_GET_ACCOUNT){
          context.setData({
            storeName:res.data.storeName
          });
        }
      }
    });
    
  },
  onHide() {
    // 页面隐藏
    //关闭后屏监听
    my.ix.offBuddyMessage();
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },


  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },

  getAccountInfo(){
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_GET_ACCOUNT,
        data: null
      },
      success: (res) => {

        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));

      },
    });
  },

  /**payresult页面逻辑方法 */
  onReprint() {
    //通知前屏重新打印
    my.ix.sendBuddyMessage({
      // 填入目标小程序的 AppID
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_REPRINT,
        data: null
      },
      success: (res) => {
        console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
      },
      fail: (res) => {
        console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
      }
    });
  },

  onNextPayFromPayResult() {
    //通知前屏跳首页
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action: ACTION_GO_HOME,
        data: null
      },
      success: (res) => {

        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));

      },
    });
  },

  //跳转到收银页面
  sendGoToCollections() {
    var commonRequest = {
      action: ACTION_GO_SCAN,
      data: null
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送收银事件到前屏小程序 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送收银事件到前屏小程序 失败 ===》 " + JSON.stringify(res));
        //发送失败重试
        // context.sendGoToCollections();
        console.log("发送收银事件到前屏小程序 ===》" + JSON.stringify(res));
      },
    });
  },

  //直接收银
  directPayment(e) {
    this.setData({scene:3}) 
  },
  //发生直接收银事件
  sendPaymentToFront(payment) {
    var commonRequest = {
      action: ACTION_DIRECT_PAYMENT,
      data: payment
    };
    let context = this;
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送直接收款事件到前屏小程序 成功 ===》" + JSON.stringify(res));
        this.setData({totalPrice:payment})
      },
      fail: (res) => {
        console.log("发送收款事件到前屏小程序 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '操作失败',
          duration: 3000,
          success: () => {
          },
        });
      },
    });
  }, 


  /**landscan页面逻辑方法 */
  //把所有的商品数据发送到后屏
  sendGoodInfoToFront() {
    let context = this;
    var commonRequest = {
      action: ACTION_GOODS,
      data: this.data
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送商品数据到前屏小程序成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送商品数据到前屏小程序 失败 ===》 " + JSON.stringify(res));
        //发送失败重试
        context.sendGoodInfoToFront();
      }
    })
  },


  //键盘完成
  onKeyBordFinished(result) {
    this.onKeyBordClose();
    if(this.data.scene == 3){
        this.sendPaymentToFront(result)
    }else if(this.data.scene == 1){
        this.sendGoodsInfoToFront(result) 
    }  
  },
  
  //把手输条码发生到前屏
  sendGoodsInfoToFront(barcode) {
    my.showLoading({});
    var commonRequest = {
      action: ACTION_REQUEST_GOOD_INFO,
      data: barcode
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("发送商品条码到前屏小程序成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("发送商品条码到前屏小程序 失败 ===》 " + JSON.stringify(res));
        my.hideLoading();
        my.showToast({
          type: 'fail',
          content: '操作失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })


  },



  //  键盘关闭
  onKeyBordClose() {
    this.setData({ scene: 0 })
  },

  // 手动输入码
  manualBarcode(e) {
    this.setData({ scene: 1 })
  },

  //清空商品信息
  clearGood(e) {
    this.setData({ goods: [] })
    this.calculation([]);
  },

  //删除商品
  deleteGood(e) {
    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode != item.barcode) {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);

  },
  //减少商品
  decreaseGood(e) {

    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        if (item.quantity != 1) {
          let quantitytemp = item.quantity
          item.quantity = quantitytemp - 1
          newGoods.push(item);

        }
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);

  },
  //增加商品
  increaseGood(e) {
    console.log(e);
    let barcode = e.target.id;
    let lastgoods = this.data.goods;
    let newGoods = []
    lastgoods.forEach(function (item, index, array) {
      if (barcode == item.barcode) {
        let quantitytemp = item.quantity
        item.quantity = quantitytemp + 1
        newGoods.push(item);
      } else {
        newGoods.push(item);
      }
    })
    this.setData({ goods: newGoods })
    this.calculation(newGoods);
  },


  //计算总价格  总数量  总优惠
  calculation(goods) {
    let quantitytemp = 0;
    let pricetemp = 0;
    goods.forEach(function (item, index, array) {
      quantitytemp = quantitytemp + item.quantity
      pricetemp = pricetemp + item.price * item.quantity
    })
    this.setData({ totalQuantity: quantitytemp, totalPrice: pricetemp })
    //数据同步到前屏
    this.sendGoodInfoToFront()
  },

  //跳转到结算等待页
  goPay(e) {
    var commonRequest = {
      action: ACTION_GO_BALANCE,
      data: ""
    };
    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: commonRequest,
      success: (res) => {
        console.log("通知前屏跳转到结算页面 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("通知前屏跳转到结算页面 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '结算失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })
  },

  waitOperateBack(){
    //直接返回到扫码页面，并且通知前屏返回
    this.goPage('landscan');

    my.ix.sendBuddyMessage({
      target: getApp().globalData.frontScreenAppId,
      data: {
        action:ACTION_GO_SCAN,
        data:null
      },
      success: (res) => {
        console.log("通知前屏跳转到结算页面 成功 ===》" + JSON.stringify(res));
      },
      fail: (res) => {
        console.log("通知前屏跳转到结算页面 失败 ===》 " + JSON.stringify(res));
        my.showToast({
          type: 'fail',
          content: '结算失败',
          duration: 3000,
          success: () => {
          },
        });
      }
    })
  },

  //用券返回
  couponBack(e) {
    this.setData({ couponUseing: false })
  },
  //使用券
  useCoupon(e) {
    this.setData({ couponUseing: true })
  }
});
